summary | shortlog | log | commit | commitdiff | tree
raw | patch | inline | side by side (parent: 75b364d)
raw | patch | inline | side by side (parent: 75b364d)
author | Junio C Hamano <junkio@cox.net> | |
Wed, 10 Jan 2007 04:39:09 +0000 (20:39 -0800) | ||
committer | Junio C Hamano <junkio@cox.net> | |
Wed, 10 Jan 2007 04:40:39 +0000 (20:40 -0800) |
When switching branches, we usually first try read-tree to make
sure that we do not lose the local changes and then updated the
HEAD using update-ref. However, we detached and updated HEAD
before these checks, which was quite bad in a repository with
local changes.
Signed-off-by: Junio C Hamano <junkio@cox.net>
sure that we do not lose the local changes and then updated the
HEAD using update-ref. However, we detached and updated HEAD
before these checks, which was quite bad in a repository with
local changes.
Signed-off-by: Junio C Hamano <junkio@cox.net>
git-checkout.sh | patch | blob | history |
diff --git a/git-checkout.sh b/git-checkout.sh
index dcf6ddbdf16c5c2c666aa01026912d9c425c55f2..8f4356d49a4935ff4a238cad3d0f90760d3e1afd 100755 (executable)
--- a/git-checkout.sh
+++ b/git-checkout.sh
# correct, it feels somewhat funny. More importantly, we do not
# want "git checkout" nor "git checkout -f" to detach HEAD.
+detached=
+detach_warn=
+
if test -z "$branch$newbranch" && test "$new" != "$old"
then
- # NEEDSWORK: we would want to have a command here
- # that allows us to detach the HEAD atomically. Perhaps
- # something like "git update-ref --detach HEAD $new"
- echo "$new" >"$GIT_DIR/HEAD.new" &&
- mv "$GIT_DIR/HEAD.new" "$GIT_DIR/HEAD" || die "Cannot detach HEAD"
-
+ detached="$new"
if test -n "$oldbranch"
then
- echo >&2 "warning: you are not on ANY branch anymore.
+ detach_warn="warning: you are not on ANY branch anymore.
If you meant to create a new branch from the commit, you need -b to
associate a new branch with the wanted checkout. Example:
- git checkout -b <new_branch_name> $arg
-"
+ git checkout -b <new_branch_name> $arg"
fi
elif test -z "$oldbranch" && test -n "$branch"
then
git-update-ref -m "checkout: Created from $new_name" "refs/heads/$newbranch" $new || exit
branch="$newbranch"
fi
- [ "$branch" ] &&
- GIT_DIR="$GIT_DIR" git-symbolic-ref HEAD "refs/heads/$branch"
+ if test -n "$branch"
+ then
+ GIT_DIR="$GIT_DIR" git-symbolic-ref HEAD "refs/heads/$branch"
+ elif test -n "$detached"
+ then
+ # NEEDSWORK: we would want a command to detach the HEAD
+ # atomically, instead of this handcrafted command sequence.
+ # Perhaps:
+ # git update-ref --detach HEAD $new
+ # or something like that...
+ #
+ echo "$detached" >"$GIT_DIR/HEAD.new" &&
+ mv "$GIT_DIR/HEAD.new" "$GIT_DIR/HEAD" ||
+ die "Cannot detach HEAD"
+ if test -n "$detach_warn"
+ then
+ echo >&2 "$detach_warn"
+ fi
+ fi
rm -f "$GIT_DIR/MERGE_HEAD"
else
exit 1